<script setup lang="ts">
import {useRepositoryImportModalStore} from "@/stores/Repository/RepositoryImportModalStore";
import Flex from "@/components/atoms/container/Flex.vue";
import BasedCodeConfigurationScreen
  from "@/components/organisms/modal/Repository/RepositoryImportModal/screens/BasedCodeConfigurationScreen.vue";
import ActionButton from "@/components/atoms/button/ActionButton.vue";
import SpinLoader from "@/components/atoms/loader/SpinLoader.vue";
import SearchAndImportRepositoryScreen
  from "@/components/organisms/modal/Repository/RepositoryImportModal/screens/SearchAndImportRepositoryScreen.vue";
import {computed} from "vue";
import FullSizeLoader from "@/components/molecules/loader/FullSizeLoader.vue";
import ImportSubmoduleRepositoryScreen
  from "@/components/organisms/modal/Repository/RepositoryImportModal/screens/ImportSubmoduleRepositoryScreen.vue";
import BaseModal from "@/components/molecules/modal/BaseModal.vue";

const repositoryImportModal = useRepositoryImportModalStore();

const showNextBtn = computed<Boolean>(() => repositoryImportModal.currentView !== 1);
const showPrevBtn = computed<Boolean>(() => repositoryImportModal.currentView === 1);
</script>

<template>
  <BaseModal
      :title="'Importer un dépôt distant' + (repositoryImportModal.importedRepository ?  ' : ' + repositoryImportModal.importedRepository.name : '')"
      :visible="repositoryImportModal.visible"
      :onShow="repositoryImportModal.show"
      :onHide="repositoryImportModal.hide"
  >
    <template #default>
      <FullSizeLoader v-if="repositoryImportModal.submitView || repositoryImportModal.showLoader">
        <SpinLoader class="w-16 h-16 "/>
      </FullSizeLoader>
      <BasedCodeConfigurationScreen v-if="repositoryImportModal.currentView === 0"/>
      <SearchAndImportRepositoryScreen v-if="repositoryImportModal.currentView === 1"/>
      <ImportSubmoduleRepositoryScreen v-if="repositoryImportModal.currentView === 2"/>
    </template>
    <template #footer>
      <Flex class="grow justify-between gap-content">
        <ActionButton
            @click="() => repositoryImportModal.previousView()"
            v-if="showPrevBtn"
        >Précédent
        </ActionButton>
        <div v-else/>
        <ActionButton
            @click="() => repositoryImportModal.submitView = true"
            class="flex gap-text"
            v-if="showNextBtn"
        >
          {{ repositoryImportModal.currentView < 2 ? "Suivant" : "Terminer" }}
        </ActionButton>
      </Flex>
    </template>
  </BaseModal>
</template>
